/*
	GLM	loader	for nsn.win

	Copyright 1999 Shinichi Honma(Rick)
*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	"PICSLICE.H"
#include	"nsn.h"
#include	"graph.h"


int	LoadGLM( LAYER *lay, int mode )
{
	char	format[]= "GLM";
	unsigned short	*gp;
	int	fn;

	lay->buf= NULL;

	if( (fn= OPEN( getfullname( lay->name ), 0 )) < 0 ){
		psierr( format, PICSLICE_EOPEN );
		return FALSE;
	}else {
		unsigned char	Buffer[16 + 4];

		READ( fn, Buffer, 16 );
		if ( Buffer[0] != 'G' || Buffer[1] != 'R' ||
				Buffer[2] != '6'|| Buffer[3] != '5' ){
			CLOSE( fn );
			psierr( format, PICSLICE_EFORMAT );
			return FALSE;
		}
		lay->h = ( Buffer[12] << 8 ) + Buffer[13];
		lay->v = ( Buffer[14] << 8 ) + Buffer[15];
	}
	
	if( !mode ){
		do {
			gp= MALLOC( lay->h * lay->v * 2 );
			if( (int)gp >= 0 )	break;
		} while( layfree() );
		if( (int)gp < 0 ){
			CLOSE( fn );
			psierr( format, PICSLICE_NOMEMORY );
			return FALSE;
		}
		if( READ( fn, gp, lay->h * lay->v * 2 ) < 0 ){
			CLOSE( fn );
			psierr( format, PICSLICE_EREAD );
			MFREE( (int)gp );
			return FALSE;
		}
		lay->buf= gp;
	}
	CLOSE( fn );
	return TRUE;
}
