/*	tviewlib.c x[XɂĂ܂	*/

/*
	MicroView.win Copyright 1995 }V
	oga@dgw.yz.yamagata-u.ac.jp

	1999 modified for nsn.win	by Rick
*/


#include <corlib.h>
#include <HS_wlib.h>
#include "nsn.h"

#define		HEVENT	(EventOpenON	\
			|EventRedrawON	\
			|EventCloseON	\
			|EventMouseSwitchON	)


static void	TextViewRedraw( TBOX *bp )
{
	DrawBuf	dbuf[32], *dp= dbuf;
	int	ymin, ymax, j, k;

	ymin= HS_WindowGetHomeY(bp->swp),	/* zʂɑ΂\ʂ̏[W */
	ymax= HS_WindowGetViewSizeY(bp->swp) + ymin;	/* \ʂ̉[W */

	DrawSetClear( dp++, 2 );	/* ʃNA */

	for( j= 0; j < bp->lines; j++ ){
		if( (bp->lp[j]).y >= ymin - FONT_Y ){	/* \͈͂܂ŃXLbv */
			break;
		}
	}

	for( k= 32 - 1; (bp->lp[j]).y <= ymax && j < bp->lines; j++ ){
		DrawSetSymbol( dp++, (bp->lp[j]).x, (bp->lp[j]).y,
						(bp->lp[j]).buf, (bp->lp[j]).attr, FONT_Y );

		if( --k <= 0 ){		/* dbuf g؂` */
			WindowDraw( bp->swp, dbuf, dp - dbuf );
			dp= dbuf;
			k= 32;
		}
	}
	if( k < 32 )	WindowDraw( bp->swp, dbuf, dp - dbuf );
}

static void
killme( TBOX *bp )
{
	WindowClose( bp->swp );		/* history window  */
	bp->swp= NULL;

	if( !(bp->pause) ){
		WindowSetEventAttr( bp->twp, INTattr );
								/* EventInterval L */
	}
	WindowRedraw( bp->twp );
}

static int	HExec( WindowID wp, EventInfo *info )
{
	TBOX	*bp= HS_WindowGetClientPointer(wp);

	switch( info->option ){
	case EventOpen:
		WindowSetEventAttr( wp, HEVENT );
		return	TRUE;

	case EventRedraw:
		TextViewRedraw( bp );
		return	TRUE;

	case EventClose:
		killme( bp );
		return TRUE;

	case EventMouseSwitch:		/* DSHELL */
	{	int	x, y;
		x= info->x;
		y= info->y;
		if( info->LeftON || info->LeftStat ){
			for(;;){
				if( info->RightON || info->RightStat ){
					killme( bp );	/* {^ŕ */
					return TRUE;
				}
				WindowScroll( bp->swp, 0, FONT_Z );
				if( WindowGetEventInfo( info ) ) {	/* ŃCxg */
					if( WindowGetChild( WindowRootID, info ) != bp->twp
						|| !(info->LeftStat) )
						break;
				}
			}
			return TRUE;
		}else if( info->RightON || info->RightStat ){
			for(;;){
				if( info->LeftON || info->LeftStat ){
					killme( bp );	/* {^ŕ */
					return TRUE;
				}
				WindowScroll( bp->swp, 0, -FONT_Z );
				if( WindowGetEventInfo( info ) ){	/* ŃCxg */
					if( WindowGetChild( WindowRootID, info ) != bp->twp
						|| !( info->RightStat ) )
						break;
				}
			}
			return	TRUE;
		}
	}
	}
	return	FALSE;
}

void	TextViewScOpen( TBOX *bp )
{
	int	v;

	if( !bp->lines )	return;
	WindowSetEventAttr( bp->twp, noINTattr );	/*	EventInterval  */

	v= (bp->lp[bp->lines - 1]).y + FONT_Y;
	if( v < WIN_V ){
		v= WIN_V;
	}

	bp->swp= WindowScrollOpen( 0, 0,
				WIN_H,
				WIN_V,
				bp->twp,
				WIN_H,
				v,
				DirectionY,
				16, FONT_Z, HExec );
	HS_WindowGetClientPointer(bp->swp)= bp;
	WindowRedraw( bp->swp );
	WindowScroll( bp->swp, 0, v - WIN_V );	/* qXgI[\ */
}
