RUNS_HUMAN_VERSION	equ	3
	.cpu 68000

	.even

	.offset 0

x1:	.ds.l	1
y1:	.ds.l	1
x2:	.ds.l	1
y2:	.ds.l	1

	.text
	.even

	.globl	_rect
_rect:
	movem.l	4(sp),a0-a2	*d, s1, s2

	move.l	(a1),d1
	cmp.l	x2(a2),d1
	bgt	unvisible

	move.l	x2(a1),d1
	cmp.l	(a2),d1
	blt	unvisible

	move.l	y1(a1),d1
	cmp.l	y2(a2),d1
	bgt	unvisible

	move.l	y2(a1),d1
	cmp.l	y1(a2),d1
	bge	visible

unvisible:
	moveq.l	#0,d0
	bra	rtn

visible:
	rept	2

	move.l	(a1)+,d1
	move.l	(a2)+,d0
	cmp.l	d1,d0
	ble	@f
	move.l	d0,d1
@@
	move.l	d1,(a0)+

	endm

	rept	2

	move.l	(a1)+,d1
	move.l	(a2)+,d0
	cmp.l	d1,d0
	bge	@f
	move.l	d0,d1
@@
	move.l	d1,(a0)+

	endm

	moveq.l	#1,d0
rtn:
	rts

	.even

	.globl	_rect2
_rect2:
	movem.l	4(sp),a0-a1	*s1, s2

	rept	2

	move.l	(a0)+,d0
	cmp.l	(a1)+,d0
	blt	out

	endm

	rept	2

	move.l	(a0)+,d0
	cmp.l	(a1)+,d0
	bgt	out

	endm

	moveq.l	#1,d0
	rts

out:
	moveq.l	#0,d0
	rts

	.globl	_rect3
_rect3:
	movem.l	4(sp),a0-a2	*d, s1, s2

	move.l	(a1),d1
	cmp.l	x2(a2),d1
	bgt	leave

	move.l	x2(a1),d1
	cmp.l	(a2),d1
	blt	leave

	move.l	y1(a1),d1
	cmp.l	y2(a2),d1
	bgt	leave

	move.l	y2(a1),d1
	cmp.l	y1(a2),d1
	bge	attach

leave:
	moveq.l	#0,d0
	bra	rtn3

attach:
	rept	2

	move.l	(a1)+,d1
	move.l	(a2)+,d0
	cmp.l	d0,d1
	ble	@f
	move.l	d0,d1
@@
	move.l	d1,(a0)+

	endm

	rept	2

	move.l	(a1)+,d1
	move.l	(a2)+,d0
	cmp.l	d0,d1
	bge	@f
	move.l	d0,d1
@@
	move.l	d1,(a0)+

	endm

	moveq.l	#1,d0
rtn3:
	rts

	.even

	.end
